Index: extensions/ContestResults/admin.php
===================================================================
--- extensions/ContestResults/admin.php	(revision 9745)
+++ extensions/ContestResults/admin.php	(revision 9745)
@@ -0,0 +1,32 @@
+<?php
+if(!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
+
+// +-----------------------------------------------------------------------+
+//				Tabsheet
+// +-----------------------------------------------------------------------+
+include_once(PHPWG_ROOT_PATH.'admin/include/tabsheet.class.php');
+$page['tab'] = (isset($_GET['tab'])) ? $_GET['tab'] : $page['tab'] = 'manage';
+	
+$tabsheet = new tabsheet();
+$tabsheet->add('manage', l10n('CR_manage_tab'), CR_ADMIN . '-manage'); 	// Gestion des concours
+$tabsheet->add('new', l10n('CR_new_tab'), CR_ADMIN . '-new'); 			// Ajouter un nouveau concours
+if (isset($_GET['contest_id'])) { 												// Editer le concours | Résultats du concours
+	$tabsheet->add($page['tab'], l10n('CR_'.$page['tab'].'_tab'), CR_ADMIN . '-' . $page['tab'] . '&amp;contest_id=' . $_GET['contest_id']);
+}
+$tabsheet->add('config', l10n('Configuration'), CR_ADMIN . '-config'); 	// Configuration
+$tabsheet->select($page['tab']);
+$tabsheet->assign();
+
+// +-----------------------------------------------------------------------+
+//				Template
+// +-----------------------------------------------------------------------+
+$template->assign(array(
+	'CR_VERSION' => CR_NAME . ' ' . CR_VERSION,
+	'CR_PATH' => CR_PATH,
+	'CR_ADMIN' => CR_ADMIN,
+));
+
+if ($page['tab'] == 'edit') { $page['tab'] = 'new'; } // L'édition se fait sur la page de création
+include(CR_PATH.'admin/' . $page['tab'] . '.php');
+
+?>
Index: extensions/ContestResults/admin/config.php
===================================================================
--- extensions/ContestResults/admin/config.php	(revision 9744)
+++ extensions/ContestResults/admin/config.php	(revision 9745)
@@ -6,5 +6,5 @@
 // +-----------------------------------------------------------------------+
 if (isset($_POST['config_submit'])) {
-	$user_config = array(
+	$conf['ContestResults'] = array(
 		'menubar_mode' => array(
 			'link' => (isset($_POST['menubar_mode_link'])) ? 1 : 0,
@@ -18,8 +18,9 @@
 			'number' => $_POST['menubar_block_number'],
 		),
+		'truncate_summary' => $_POST['truncate_summary'],
 	);
 	
-	pwg_query("UPDATE " . CONFIG_TABLE . " SET `value` = '" . serialize($user_config) . "' WHERE `param` = 'ContestResults';");
-	redirect(CR_ADMIN . '&amp;tab=config&amp;msg=saved');
+	pwg_query("UPDATE " . CONFIG_TABLE . " SET `value` = '" . serialize($conf['ContestResults']) . "' WHERE `param` = 'ContestResults';");
+	$page['infos'][] = l10n('Information data registered in database');
 }	
 
@@ -27,8 +28,4 @@
 //				Définition des variables template
 // +-----------------------------------------------------------------------+
-if (isset($_GET['msg']) AND $_GET['msg'] == 'saved')
-	array_push($page['infos'], l10n('Information data registered in database'));
-	
-
 $template->assign(array(
 	'MODE_LINK' => ($conf['ContestResults']['menubar_mode']['link']) ? 'checked="checked"' : '',
@@ -37,4 +34,5 @@
 	'LINK_SPECIALS' => ($conf['ContestResults']['menubar_link']['specials']) ? 'checked="checked"' : '',
 	'BLOCK_NUMBER' => $conf['ContestResults']['menubar_block']['number'],
+	'TRUNCATE_SUMMARY' => $conf['ContestResults']['truncate_summary'],
 ));
 
@@ -44,3 +42,4 @@
 $template->set_filenames(array('plugin_admin_content' => dirname(__FILE__).'/template/config.tpl'));
 $template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');
+
 ?>
Index: extensions/ContestResults/admin/get_tn.php
===================================================================
--- extensions/ContestResults/admin/get_tn.php	(revision 9744)
+++ extensions/ContestResults/admin/get_tn.php	(revision 9745)
@@ -9,5 +9,5 @@
 
 if (!pwg_db_num_rows($image)) {
-	$themeconf = $template->get_template_vars('themeconf');
+	//$themeconf = $template->get_template_vars('themeconf');
 	//$data['TN_SRC'] = $themeconf['admin_icon_dir'] . '/errors.png';
 	$data['TN_SRC'] = 'admin/themes/default/icon/errors.png';
Index: extensions/ContestResults/admin/manage.php
===================================================================
--- extensions/ContestResults/admin/manage.php	(revision 9744)
+++ extensions/ContestResults/admin/manage.php	(revision 9745)
@@ -8,9 +8,10 @@
 	pwg_query('DELETE FROM ' . CR_TABLE_1 . ' WHERE id = ' . $_GET['delete_contest'] . ';');
 	pwg_query('DELETE FROM ' . CR_TABLE_2 . ' WHERE contest_id = ' . $_GET['delete_contest'] . ';');
-	redirect(CR_ADMIN .'&amp;tab=manage&amp;msg=deleted');
+	$page['infos'][] = l10n('CR_contest_deleted');
 }
 
 if (isset($_GET['msg'])){
-	array_push($page['infos'], l10n('CR_contest_'. $_GET['msg']));
+	$_GET['msg'] = explode('.', $_GET['msg']);
+	$page[$_GET['msg'][0]][] = l10n('CR_'. $_GET['msg'][1]);
 }
 
@@ -29,20 +30,17 @@
 
 while ($contest = pwg_db_fetch_assoc($contests)) {
-	if (is_date_passed($contest['date_end'])) {
-		$contest['status'] = 'finished';
-	} else { 
-		$contest['status'] = 'pending';
-	}
+	$contest = array_merge($contest, get_contest_status($contest['date_begin'],$contest['date_end']));
+
 	$template->append('contests_'.$contest['status'], array(
-		'NAME' => trigger_event('render_CR_content', $contest['name']),
-		'VISIBLE' => $contest['visible'],
+		'NAME' => 		trigger_event('render_CR_content', $contest['name']),
+		'VISIBLE' => 	$contest['visible'],
 		'DATE_BEGIN' => format_date($contest['date_begin']),
-		'DATE_END' => format_date($contest['date_end']),
-		'LOGO' => $contest['logo'],
-		'U_RESULTS' => CR_ADMIN . '&amp;tab=results&amp;contest_id=' . $contest['id'],
-		'U_EDIT' => CR_ADMIN . '&amp;tab=edit&amp;contest_id=' . $contest['id'],
-		'U_DELETE' => CR_ADMIN . '&amp;delete_contest=' . $contest['id'],
-		'URL' => CR_PUBLIC . $contest['id'] . '-' . str2url(trigger_event('render_CR_content', $contest['name'])),
-		'DAYS' => DateDiff($contest['date_end'],date('Y-m-d')),
+		'DATE_END' => 	format_date($contest['date_end']),
+		'LOGO' => 		$contest['logo'],
+		'U_RESULTS' => 	CR_ADMIN . '-results&amp;contest_id=' . $contest['id'],
+		'U_EDIT' => 	CR_ADMIN . '-edit&amp;contest_id=' . $contest['id'],
+		'U_DELETE' => 	CR_ADMIN . '-manage&amp;delete_contest=' . $contest['id'],
+		'URL' => 		CR_PUBLIC . $contest['id'] . '-' . str2url(trigger_event('render_CR_content', $contest['name'])),
+		'DAYS' => 		$contest['days'],
 	));
 }
@@ -53,3 +51,4 @@
 $template->set_filenames(array('plugin_admin_content' => dirname(__FILE__).'/template/manage.tpl'));
 $template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');
+
 ?>
Index: extensions/ContestResults/admin/new.php
===================================================================
--- extensions/ContestResults/admin/new.php	(revision 9744)
+++ extensions/ContestResults/admin/new.php	(revision 9745)
@@ -8,18 +8,16 @@
 	if ($_POST['name'] != null) {
 		// Mise en forme des descriptions
-		if (isset($_POST['description'])) {
-			$new_description = array();
-			foreach ($_POST['description'] as $data) {
-				$new_description[] = array(
-					'name' => $data['name'],
-					'content' => $data['content']
-				);
+		if (isset($_POST['description'])) {				
+			for ($i=0; $i<=count($_POST['description']); $i++) {
+				unset($_POST['description'][$i]['rank']);
 			}
 			// encoder le tableau sérialisé est le seul moyen que j'ai trouvé pour pas perdre les caractères spéciaux et planter unserialize
-			$_POST['description'] = base64_encode(serialize($new_description));
+			$_POST['description'] = base64_encode(serialize($_POST['description']));
+		} else {
+			$_POST['description'] = null;
 		}
 			
 		// Modification d'un concours
-		if (isset($_GET['contest_id'])) {	
+		if (isset($_GET['contest_id']) AND get_contest_name($_GET['contest_id'])) {	
 			pwg_query("UPDATE " . CR_TABLE_1 . " SET
 				`name` = '" . $_POST['name'] ."',
@@ -37,5 +35,5 @@
 				redirect(CR_PUBLIC . $_GET['contest_id'] . '-' . str2url(trigger_event('render_CR_content', $_POST['name'])));
 			} else {
-				redirect(CR_ADMIN .'&amp;tab=manage&amp;msg=saved');
+				redirect(CR_ADMIN .'-manage&amp;msg=infos.contest_saved');
 			}
 			
@@ -63,9 +61,10 @@
 					'" . $_POST['description'] ."'
 				);");
-			redirect(CR_ADMIN .'&amp;tab=manage&amp;msg=added');
+			
+			redirect(CR_ADMIN .'-manage&amp;msg=infos.contest_added');
 		}
 		
 	} else {
-		array_push($page['errors'], l10n('CR_name_empty'));
+		$page['errors'][] = l10n('CR_name_empty');
 	}
 }
@@ -75,5 +74,5 @@
 //				Définition des variables template
 // +-----------------------------------------------------------------------+	
-// Formulaire incomplet ##############################################################################################################################################################
+// Formulaire incomplet
 if ($page['errors']) {
 	$template->assign(array(
@@ -100,5 +99,5 @@
 
 // Edition d'un concours
-} else if (isset($_GET['contest_id'])) {
+} else if (isset($_GET['contest_id']) AND get_contest_name($_GET['contest_id'])) {
 	$query = "SELECT * FROM " . CR_TABLE_1 . " WHERE id = " . $_GET['contest_id'] . ";";
 	$contest = pwg_db_fetch_assoc(pwg_query($query));
@@ -115,5 +114,5 @@
 	));
 	
-	if ($contest['description'] != null) {
+	if (!empty($contest['description'])) {
 		$contest['description'] = unserialize(base64_decode($contest['description']));
 		$i=0;
@@ -146,3 +145,4 @@
 $template->set_filenames(array('plugin_admin_content' => dirname(__FILE__).'/template/new.tpl'));
 $template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');
+
 ?>
Index: extensions/ContestResults/admin/results.php
===================================================================
--- extensions/ContestResults/admin/results.php	(revision 9744)
+++ extensions/ContestResults/admin/results.php	(revision 9745)
@@ -8,23 +8,37 @@
 	pwg_query("DELETE FROM " . CR_TABLE_2 . " WHERE `contest_id` = " . $_GET['contest_id'] .";");
 	
+	$registered_ids = array();
+	$_DUPLICATE = array();
+	
 	foreach ($_POST['results'] AS $i => $data) {
-		pwg_query("INSERT INTO " . CR_TABLE_2 . "
-			(
-				image_id, 
-				contest_id, 
-				rank,
-				comment, 
-				author
-			)
-			VALUES(
-				'" . $data['image_id'] ."',
-				'" . $_GET['contest_id'] ."',
-				'" . $data['rank'] ."',
-				'" . $data['comment'] ."',
-				'" . $data['author'] . "'
-			);");
+		if (!in_array($data['image_id'], $registered_ids)) {
+			$registered_ids[] = $data['image_id'];
+			
+			pwg_query("INSERT INTO " . CR_TABLE_2 . "
+				(
+					image_id, 
+					contest_id, 
+					rank,
+					comment, 
+					author
+				)
+				VALUES(
+					'" . $data['image_id'] ."',
+					'" . $_GET['contest_id'] ."',
+					'" . $data['rank'] ."',
+					'" . $data['comment'] ."',
+					'" . $data['author'] . "'
+				);");
+		
+		} else {
+			$_DUPLICATE[] = $data;
+		}
 	}
 	
-	redirect(CR_ADMIN . '&amp;tab=results&amp;msg=saved&amp;contest_id=' . $_GET['contest_id']);
+	if (isset($_GET['redirect']) AND $_GET['redirect'] == 'page') {
+		redirect(CR_PUBLIC . $_GET['contest_id'] . '-' . str2url(trigger_event('render_CR_content', get_contest_name($_GET['contest_id']))) . '#results');
+	} else if (!isset($_DUPLICATE)) {
+		$page['infos'][] = l10n('CR_results_saved');
+	}
 }
 
@@ -32,52 +46,86 @@
 //				Affichage des résultats
 // +-----------------------------------------------------------------------+
-if (isset($_GET['msg']) AND $_GET['msg'] == 'saved')
-	array_push($page['infos'], l10n('CR_results_saved'));
+
+if (!get_contest_name($_GET['contest_id'])) {
+	redirect(CR_ADMIN .'-manage&amp;msg=errors.notavailable');
 	
-	
-// Nom du concours
-$query = "SELECT name FROM " . CR_TABLE_1 . " WHERE id = " . $_GET['contest_id'] . ";";
-$contest = pwg_db_fetch_assoc(pwg_query($query));
+} else {
+	// Nom du concours
+	$query = "SELECT name FROM " . CR_TABLE_1 . " WHERE id = " . $_GET['contest_id'] . ";";
+	$contest = pwg_db_fetch_assoc(pwg_query($query));
 
-$template->assign(array(
-	'NAME' => trigger_event('render_CR_content', $contest['name']),
-	'CONTEST_ID' => $_GET['contest_id']
-));
+	$template->assign(array(
+		'NAME' => trigger_event('render_CR_content', $contest['name']),
+		'CONTEST_ID' => $_GET['contest_id']
+	));
 
-// Résultats
-$results = pwg_query("SELECT * FROM " . CR_TABLE_2 . " WHERE contest_id = " . $_GET['contest_id'] . " ORDER BY rank;");
+	// Résultats en double
+	if (isset($_DUPLICATE)) {
+		foreach ($_DUPLICATE AS $result) {
+			$data = array(
+				'RANK' => 0,
+				'IMAGE_ID' => $result['image_id'],
+				'AUTHOR' => $result['author'],
+				'COMMENT' => $result['comment'],
+				'ERROR' => true,
+			);
+			
+			// Infos de l'image
+			$image = pwg_query("SELECT id, name, file, path, tn_ext
+				FROM " . IMAGES_TABLE . "
+				WHERE id = " . $result['image_id'] . ";");
+			
+			if (!pwg_db_num_rows($image)) {
+				$themeconf = $template->get_template_vars('themeconf');
+				$data['TN_SRC'] = $themeconf['admin_icon_dir'] . '/errors.png';
+				$data['IMAGE_NAME'] = 'N/A';		
+			} else {
+				$image = pwg_db_fetch_assoc($image);
+				$data['TN_SRC'] = get_thumbnail_url($image);
+				$data['IMAGE_NAME'] = (empty($image['name'])) ? get_name_from_file($image['file']) : $image['name'];
+			}
+			
+			$page['errors'][] = l10n_dec('CR_duplicate_result %d', 'CR_duplicate_result %d', $result['image_id']);
+			$template->append('results', $data);
+		}
+	}
 
-while ($result = pwg_db_fetch_assoc($results)) {
-	$data = array(
-		'RANK' => $result['rank'],
-		'IMAGE_ID' => $result['image_id'],
-		'AUTHOR' => $result['author'],
-		'COMMENT' => $result['comment'],
-	);
-	
-	// Infos de l'image
-	$image = pwg_query("SELECT id, name, file, path, tn_ext
-		FROM " . IMAGES_TABLE . "
-		WHERE id = " . $result['image_id'] . ";");
-	
-	if (!pwg_db_num_rows($image)) {
-		$themeconf = $template->get_template_vars('themeconf');
-		$data['TN_SRC'] = $themeconf['admin_icon_dir'] . '/errors.png';
-		$data['IMAGE_NAME'] = 'N/A';
-		$page['errors'][] = l10n_dec('CR_id_unknown %d', 'CR_id_unknown %d', $result['image_id']);
+	// Résultats enregistrés
+	$results = pwg_query("SELECT * FROM " . CR_TABLE_2 . " WHERE contest_id = " . $_GET['contest_id'] . " ORDER BY rank;");
+
+	while ($result = pwg_db_fetch_assoc($results)) {
+		$data = array(
+			'RANK' => $result['rank'],
+			'IMAGE_ID' => $result['image_id'],
+			'AUTHOR' => $result['author'],
+			'COMMENT' => $result['comment'],
+		);
 		
-	} else {
-		$image = pwg_db_fetch_assoc($image);
-		$data['TN_SRC'] = get_thumbnail_url($image);
-		$data['IMAGE_NAME'] = (empty($image['name'])) ? get_name_from_file($image['file']) : $image['name'];
+		// Infos de l'image
+		$image = pwg_query("SELECT id, name, file, path, tn_ext
+			FROM " . IMAGES_TABLE . "
+			WHERE id = " . $result['image_id'] . ";");
+		
+		if (!pwg_db_num_rows($image)) {
+			$themeconf = $template->get_template_vars('themeconf');
+			$data['TN_SRC'] = $themeconf['admin_icon_dir'] . '/errors.png';
+			$data['IMAGE_NAME'] = 'N/A';
+			$data['ERROR'] = true;
+			$page['errors'][] = l10n_dec('CR_id_unknown %d', 'CR_id_unknown %d', $result['image_id']);
+		} else {
+			$image = pwg_db_fetch_assoc($image);
+			$data['TN_SRC'] = get_thumbnail_url($image);
+			$data['IMAGE_NAME'] = (empty($image['name'])) ? get_name_from_file($image['file']) : $image['name'];
+		}
+		
+		$template->append('results', $data);
 	}
-	
-	$template->append('results', $data);
+
+	// +-----------------------------------------------------------------------+
+	//				Template
+	// +-----------------------------------------------------------------------+
+	$template->set_filenames(array('plugin_admin_content' => dirname(__FILE__) . '/template/results.tpl'));
+	$template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');
 }
 
-// +-----------------------------------------------------------------------+
-//				Template
-// +-----------------------------------------------------------------------+
-$template->set_filenames(array('plugin_admin_content' => dirname(__FILE__) . '/template/results.tpl'));
-$template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');
 ?>
Index: extensions/ContestResults/include/compatibility.inc.php
===================================================================
--- extensions/ContestResults/include/compatibility.inc.php	(revision 9745)
+++ extensions/ContestResults/include/compatibility.inc.php	(revision 9745)
@@ -0,0 +1,75 @@
+<?php
+
+// compatibilité avec les versions < 1.1 (ajout d'une entrée de configuration)
+if (!isset($conf['ContestResults'])) {
+	pwg_query("INSERT INTO " . CONFIG_TABLE . "(param,value,comment) VALUES('ContestResults', '" . default_config . "', 'Parametres du plugin ContestResults');");
+}
+
+// compatibilité avec les versions < 1.2 (suppression option d'affichage)
+$field = pwg_query("SHOW COLUMNS FROM `" . $prefixeTable . "contests` LIKE 'presentation_display'");
+if (pwg_db_num_rows($field)) {
+	pwg_query("ALTER TABLE `" . $prefixeTable . "contests` 
+		DROP `presentation_display`,
+		DROP `rules_display`,
+		DROP `prices_display`,
+		DROP `final_display`;"
+	);
+}
+
+// compatibilité avec les versions < 1.3.a (suppression option status, regroupement des champs de description)
+$field = pwg_query("SHOW COLUMNS FROM `" . $prefixeTable . "contests` LIKE 'status'");
+if (pwg_db_num_rows($field)) {
+	pwg_query("ALTER TABLE `" . $prefixeTable . "contests` DROP `status`");
+	pwg_query("ALTER TABLE `" . $prefixeTable . "contests` ADD `description` TEXT NULL");
+	
+	$contests = pwg_query("SELECT * FROM `" . $prefixeTable . "contests`");
+	while ($contest = pwg_db_fetch_assoc($contests)) {
+		$new_description = array();
+		if (!empty($contest['presentation'])) {
+			$new_description[] = array(
+				'name' => 'Presentation[lang=fr]Présentation[/lang][lang=es]Presentación[/lang][lang=lv]Prezentacija[/lang]',
+				'content' => $contest['presentation'],
+			);
+		}
+		if (!empty($contest['rules'])) {
+			$new_description[] = array(
+				'name' => 'Rules[lang=fr]Règles[/lang][lang=es]Restricciones[/lang][lang=lv]Noteikumi[/lang]',
+				'content' => $contest['rules'],
+			);
+		}
+		if (!empty($contest['prices'])) {
+			$new_description[] = array(
+				'name' => 'Prices[lang=fr]Prix[/lang][lang=es]Precios[/lang][lang=lv]Cenas[/lang]',
+				'content' => $contest['prices'],
+			);
+		}
+		if (!empty($contest['final'])) {
+			$new_description[] = array(
+				'name' => 'Conclusion[lang=fr]Conclusion[/lang][lang=es]Conclusión[/lang][lang=lv]Beigsana[/lang]',
+				'content' => $contest['final'],
+			);
+		}
+	
+		$new_description = base64_encode(serialize($new_description));
+		pwg_query("UPDATE `" . $prefixeTable . "contests`
+			SET description = '". $new_description ."'
+			WHERE id = ". $contest['id'] .";"
+		);
+	}
+	
+	pwg_query("ALTER TABLE `" . $prefixeTable . "contests` 
+		DROP `presentation`,
+		DROP `rules`,
+		DROP `prices`,
+		DROP `final`;"
+	);
+}
+
+// compatibilité avec les versions < 1.3.b (ajout d'un paramètre de config)
+$conf['ContestResults'] = unserialize($conf['ContestResults']);
+if (!isset($conf['ContestResults']['truncate_summary'])) {
+	$conf['ContestResults']['truncate_summary'] = 350;
+	pwg_query("UPDATE " . CONFIG_TABLE . " SET value='" . serialize($conf['ContestResults']) . "' WHERE param = 'ContestResults';");
+}
+
+?>
Index: extensions/ContestResults/include/cr_main.php
===================================================================
--- extensions/ContestResults/include/cr_main.php	(revision 9744)
+++ extensions/ContestResults/include/cr_main.php	(revision 9745)
@@ -17,7 +17,7 @@
 
 while ($contest = pwg_db_fetch_assoc($contests)) {
+	$contest = array_merge($contest, get_contest_status($contest['date_begin'],$contest['date_end']));
+		
 	if ($contest['visible'] OR is_admin()) {
-		$contest['finished'] = is_date_passed($contest['date_end']);
-		
 		// infos sur le concours
 		$item =  array(
@@ -25,15 +25,15 @@
 			'NAME' => trigger_event('render_CR_content', $contest['name']),
 			'VISIBLE' => $contest['visible'],
-			'FINISHED' => $contest['finished'],
+			'STATUS' => $contest['status'],
 			'DATE_END' => format_date($contest['date_end']),
 			'DATE_BEGIN' => format_date($contest['date_begin']),
 			'LOGO' => $contest['logo'],
-			'SUMMARY' => CR_cut_string(trigger_event('render_CR_content', $contest['summary']), 350),
+			'SUMMARY' => CR_cut_string(trigger_event('render_CR_content', $contest['summary']), $conf['ContestResults']['truncate_summary']),
 			'URL' => CR_PUBLIC . $contest['id'] . '-' . str2url(trigger_event('render_CR_content', $contest['name'])),
-			'DAYS' => DateDiff($contest['date_end'], date('Y-m-d')),
+			'DAYS' => $contest['days'],
 		);
 		
 		// podium si terminé
-		if ($contest['finished'] == true) {
+		if ($contest['status'] == 'finished') {
 			$results = pwg_query("SELECT
 					i.id,
Index: extensions/ContestResults/include/cr_menubar.php
===================================================================
--- extensions/ContestResults/include/cr_menubar.php	(revision 9744)
+++ extensions/ContestResults/include/cr_menubar.php	(revision 9745)
@@ -5,6 +5,5 @@
 //				Triggers
 // +-----------------------------------------------------------------------+
-$config = unserialize($conf['ContestResults']);
-if ($config['menubar_mode']['block']) {
+if ($conf['ContestResults']['menubar_mode']['block']) {
 	add_event_handler('blockmanager_register_blocks', 'CR_register_menubar_blocks');
 }
@@ -25,5 +24,5 @@
 function CR_menubar_apply($menu_ref_arr) {
 	global $template, $conf;
-	$config = unserialize($conf['ContestResults']);
+	//$config = unserialize($conf['ContestResults']);
 	$menu = &$menu_ref_arr[0];
 	
@@ -43,6 +42,8 @@
 
 		$m = 0; // compteur pour limiter le nombre de concours affichés
-		while($contest = pwg_db_fetch_assoc($contests)){
-			if (($contest['visible'] OR is_admin()) AND $m < $config['menubar_block']['number']) {
+		while ($contest = pwg_db_fetch_assoc($contests)) {
+			$contest = array_merge($contest, get_contest_status($contest['date_begin'],$contest['date_end']));
+			
+			if (($contest['visible'] OR is_admin()) AND $m < $conf['ContestResults']['menubar_block']['number']) {
 				array_push($data, array(
 					'URL' => CR_PUBLIC . $contest['id'] . '-' . str2url(trigger_event('render_CR_content', $contest['name'])),
@@ -50,6 +51,6 @@
 					'DATE' => format_date($contest['date_begin']) . ' - ' . format_date($contest['date_end']),
 					'VISIBLE' => $contest['visible'],
-					'FINISHED' => is_date_passed($contest['date_end']),
-					'DAYS' => DateDiff($contest['date_end'],date('Y-m-d')),
+					'STATUS' => $contest['status'],
+					'DAYS' => $contest['days'],
 				));
 			}
@@ -67,5 +68,5 @@
 	
 	// Block Menu - ajout d'un lien dans le bloc Menu
-	if ($config['menubar_mode']['link'] AND $config['menubar_link']['menu'] AND ($block = $menu->get_block('mbMenu')) != null) {
+	if ($conf['ContestResults']['menubar_mode']['link'] AND $conf['ContestResults']['menubar_link']['menu'] AND ($block = $menu->get_block('mbMenu')) != null) {
 		array_push($block->data, array(
 			'URL' => CR_PUBLIC,
@@ -76,5 +77,5 @@
 	
 	// Block Specials - ajout d'un lien dans le bloc Specials
-	if($config['menubar_mode']['link'] AND $config['menubar_link']['specials'] AND ($block = $menu->get_block('mbSpecials')) != null){
+	if($conf['ContestResults']['menubar_mode']['link'] AND $conf['ContestResults']['menubar_link']['specials'] AND ($block = $menu->get_block('mbSpecials')) != null){
 		array_push($block->data, array(
 			'URL' => CR_PUBLIC,
Index: extensions/ContestResults/include/cr_page.php
===================================================================
--- extensions/ContestResults/include/cr_page.php	(revision 9744)
+++ extensions/ContestResults/include/cr_page.php	(revision 9745)
@@ -6,111 +6,106 @@
 // +-----------------------------------------------------------------------+
 if (is_admin()) {
-	$template->assign('U_EDIT', CR_ADMIN . '&amp;tab=edit&amp;contest_id=' . $page['contest'] . '&amp;redirect=page');
-	$template->assign('U_RESULTS', CR_ADMIN . '&amp;tab=results&amp;contest_id=' . $page['contest']);
+	$template->assign('U_EDIT', CR_ADMIN . '-edit&amp;contest_id=' . $page['contest'] . '&amp;redirect=page');
+	$template->assign('U_RESULTS', CR_ADMIN . '-results&amp;contest_id=' . $page['contest'] . '&amp;redirect=page');
 }
 
 // Infos du concours
-$contest = pwg_query("SELECT * FROM " . CR_TABLE_1 . " WHERE id=" . $page['contest'] . ";");
+$contest = pwg_db_fetch_assoc(pwg_query("SELECT * FROM " . CR_TABLE_1 . " WHERE id=" . $page['contest'] . ";"));
+$contest = array_merge($contest, get_contest_status($contest['date_begin'],$contest['date_end']));
 
-if (pwg_db_num_rows($contest)) { 
-	$contest = pwg_db_fetch_assoc($contest);
-	$contest['finished'] = is_date_passed($contest['date_end']);
-	
-	// Concours non-publique
-	if (!$contest['visible']) {
-		check_status(ACCESS_ADMINISTRATOR);
-	}
-	
-	// Paramètres généraux
-	$template->assign(array(
-		'ID' => $contest['id'],
-		'NAME' => trigger_event('render_CR_content', $contest['name']),
-		'VISIBLE' => $contest['visible'],
-		'FINISHED' => $contest['finished'],
-		'DATE_BEGIN' => format_date($contest['date_begin']),
-		'DATE_END' => format_date($contest['date_end']),
-		'LOGO' => $contest['logo'],
-		'BANNER' => $contest['banner'],
-		'URL' => CR_PUBLIC . $contest['id'] . '-' . str2url(trigger_event('render_CR_content', $contest['name'])),
-		'DAYS' => DateDiff($contest['date_end'], date('Y-m-d')),
-	));
-	
-	// Les quatre zones texte
-	if (!empty($contest['description'])) {
-		$contest['description'] = unserialize(base64_decode($contest['description']));
-		foreach ($contest['description'] as $desc) {
-			$template->append('description', array(
-				'NAME' => trigger_event('render_CR_content', stripslashes($desc['name'])),
-				'CONTENT' => trigger_event('render_CR_content', stripslashes($desc['content'])),
-			));
-		}
-	}
-	
-	// Affichage des résultats
-	if ($contest['finished'] == true) {
-		// Infos des résultats
-		$results = pwg_query("SELECT * FROM " . CR_TABLE_2 . " WHERE contest_id=" . $contest['id'] . " ORDER BY rank ASC;");
-		
-		while ($result = pwg_db_fetch_assoc($results)) {
-			// Infos de l'image
-			$query = "SELECT
-					i.id,
-					i.name,
-					i.file,
-					i.path,
-					i.tn_ext,
-					ic.category_id
-				FROM " . IMAGES_TABLE . " AS i
-				INNER JOIN " . IMAGE_CATEGORY_TABLE . " AS ic
-				ON ic.image_id = i.id
-				WHERE i.id = " . $result['image_id'] . ";";
-			$image = pwg_db_fetch_assoc(pwg_query($query));
-
-			// retrieving category informations
-			$query = "SELECT 
-					id, 
-					name, 
-					permalink, 
-					uppercats
-				FROM " . CATEGORIES_TABLE."
-				WHERE id = " . $image['category_id'] . ";";
-			$image['cat'] = pwg_db_fetch_assoc(pwg_query($query));
-	
-			// link to the full size picture
-			$image['url'] = make_picture_url(array(
-				'category' => $image['cat'],
-				'image_id' => $image['id'],
-				'image_file' => $image['file'],
-			));			
-			
-			// Template
-			if (in_array($result['rank'], array(1,2,3))) {
-				$data = array(
-					'RANK' => $result ['rank'],
-					'AUTHOR' => $result['author'],
-					'IMAGE_SRC' => str_replace('thumbnail/'.$conf['prefix_thumbnail'], null, get_thumbnail_url($image)),
-					'IMAGE_URL' => $image['url'],
-					'IMAGE_NAME' => (empty($image['name'])) ? get_name_from_file($image['file']) : $image['name'],
-					'COMMENT' => CR_cut_string(trigger_event('render_CR_content', $result['comment']), 450),
-				);
-			}else{
-				$data = array(
-					'RANK' => $result ['rank'],
-					'AUTHOR' => $result['author'],
-					'TN_SRC' => get_thumbnail_url($image),
-					'IMAGE_URL' => $image['url'],
-					'IMAGE_NAME' => (empty($image['name'])) ? get_name_from_file($image['file']) : $image['name'],
-				);
-			}
-			$template->append('RESULTS', $data);
-		}
-	}
-	
-	$template->set_filenames(array('index'=> dirname(__FILE__).'/../template/cr_page.tpl'));
-	
-} else {
-	page_not_found(l10n('CR_notavailable'));
+// Concours non-publique
+if (!$contest['visible']) {
+	check_status(ACCESS_ADMINISTRATOR);
 }
 
+// Paramètres généraux
+$template->assign(array(
+	'ID' => $contest['id'],
+	'NAME' => trigger_event('render_CR_content', $contest['name']),
+	'VISIBLE' => $contest['visible'],
+	'STATUS' => $contest['status'],
+	'DATE_BEGIN' => format_date($contest['date_begin']),
+	'DATE_END' => format_date($contest['date_end']),
+	'LOGO' => $contest['logo'],
+	'BANNER' => $contest['banner'],
+	'URL' => CR_PUBLIC . $contest['id'] . '-' . str2url(trigger_event('render_CR_content', $contest['name'])),
+	'DAYS' => $contest['days'],
+));
+
+// Les quatre zones texte
+if (!empty($contest['description'])) {
+	$contest['description'] = unserialize(base64_decode($contest['description']));
+	foreach ($contest['description'] as $desc) {
+		$template->append('description', array(
+			'NAME' => trigger_event('render_CR_content', stripslashes($desc['name'])),
+			'CONTENT' => trigger_event('render_CR_content', stripslashes($desc['content'])),
+		));
+	}
+}
+
+// Affichage des résultats
+if ($contest['status'] == 'finished') {
+	// Infos des résultats
+	$results = pwg_query("SELECT * FROM " . CR_TABLE_2 . " WHERE contest_id=" . $contest['id'] . " ORDER BY rank ASC;");
+	$i=0;
+	while ($result = pwg_db_fetch_assoc($results)) {
+		$i++;
+		// Infos de l'image
+		$query = "SELECT
+				i.id,
+				i.name,
+				i.file,
+				i.path,
+				i.tn_ext,
+				ic.category_id
+			FROM " . IMAGES_TABLE . " AS i
+			INNER JOIN " . IMAGE_CATEGORY_TABLE . " AS ic
+			ON ic.image_id = i.id
+			WHERE i.id = " . $result['image_id'] . ";";
+		$image = pwg_db_fetch_assoc(pwg_query($query));
+
+		// retrieving category informations
+		$query = "SELECT 
+				id, 
+				name, 
+				permalink, 
+				uppercats
+			FROM " . CATEGORIES_TABLE."
+			WHERE id = " . $image['category_id'] . ";";
+		$image['cat'] = pwg_db_fetch_assoc(pwg_query($query));
+
+		// link to the full size picture
+		$image['url'] = make_picture_url(array(
+			'category' => $image['cat'],
+			'image_id' => $image['id'],
+			'image_file' => $image['file'],
+		));			
+		
+		// Template
+		if (in_array($result['rank'], array(1,2,3))) {
+			$data = array(
+				'RANK' => $result ['rank'],
+				'AUTHOR' => $result['author'],
+				'IMAGE_SRC' => str_replace('thumbnail/'.$conf['prefix_thumbnail'], null, get_thumbnail_url($image)),
+				'IMAGE_URL' => $image['url'],
+				'IMAGE_NAME' => (empty($image['name'])) ? get_name_from_file($image['file']) : $image['name'],
+				'COMMENT' => CR_cut_string(trigger_event('render_CR_content', $result['comment']), 450),
+			);
+		}else{
+			$data = array(
+				'RANK' => $result ['rank'],
+				'AUTHOR' => $result['author'],
+				'TN_SRC' => get_thumbnail_url($image),
+				'IMAGE_URL' => $image['url'],
+				'IMAGE_NAME' => (empty($image['name'])) ? get_name_from_file($image['file']) : $image['name'],
+			);
+		}
+		$template->append('RESULTS', $data);
+	}
+	$template->assign('NB_RESULTS', $i);
+}
+
+$template->set_filenames(array('index'=> dirname(__FILE__).'/../template/cr_page.tpl'));
+	
 
 // +-----------------------------------------------------------------------+
